/*
 * Title  : sho_role_tab_priv.sql
 * Author : EXADIME LLC
 * Created: 14-Sep-2025
 * Updated: 24-Mar-2026
 * Release: 1.0.0
 * Purpose: Lists all the table privileges granted to the given role.
 * Comment: Shows only table privileges.
 * History: Added search filter; sort.
 */

start oracle.ini

set echo off
set feedback off
set serverout on
set termout on

set linesize 100
set pagesize 0
set pause off
set long 80

set heading on
set headsep on
set underline on
set colsep " "

set define on
set verify off
set escape off
set embedded on

accept p_role char prompt 'Enter Role Name: '
accept p_txt char prompt "Enter search string (Schema/Table/Privilege): "

col sno		format 9999	heading "#"
col owner	format a30	heading "Owner"
col table_name	format a30	heading "Table"
col privilege	format a30	heading "Privilege"

spool &&rpt_dir/sho_role_tab_priv.rpt

select 
	rownum sno,
	owner,
	table_name,
	privilege
from(
	select 
		owner,
		table_name,
		privilege
       from 
		dba_tab_privs a,
		dba_roles b
       where 
		a.grantee=b.role
       and	
		a.grantee=upper('&&p_role')
       order by
		1,2
) where
	(owner like trim(upper('%&&p_txt%')) or table_name like trim(upper('%&&p_txt%')) or privilege like trim(upper('%&&p_txt%')));

spool off

clear columns

set embedded off
set escape off
set verify on
set define on

set colsep " "
set underline on
set headsep on
set heading on

set pause off
set pagesize 24
set linesize 80
set long 80

set termout on
set serverout off
set feedback on
set echo off
